<template>
    <div>
        <ob-table
            :columns="groupColumns"
            :sub-columns="columns"
            :functionalPanel="true"
            :remote-opt="{
              method: getTransportGroups
            }"
            :sub-remote-opt="{
              method: getSubtableData
            }"
            :loading="isLoading"
            :show-add-button="true"
            add-button-text="Добавить группу типов транспорта"
            is-sub-table-action
            :sub-table-action="subTableAction"
            toggle-sub-table-by-click-at-whole-row
            @subTableAction="onEditGroup"
            is-fixed-header
            :tableLayoutFixed="false"
            :is-functional-filter="false"
            :is-functional-group="false"
            :is-functional-sort="false"
            @add="onAddGroup"
            ref="transportClusteringTable"
            data-qa="tableTransportClustersBP"
        >
          <template v-slot:title="{ data }">
            <div class="sub-table-header__title edit-group-container">
              <i class="icon" :class="getIconClass(data.item.transportationWay)" />
              <input
                v-model="data.item.title"
                class="edit-group-title-input"
                type="text"
                @change="changeGroupTitle(data.item.title, data.item.uuid)"
                @click.stop
                data-qa="inputTransportTitleBP"
              />
            </div>
          </template>

          <template v-slot:createdAt="{ data }">
            {{ data.item.createdAt | date('DD.MM.YYYY') }}
          </template>

          <template v-slot:authorUuid="{ data }">
            {{ data.item.userInfo }}
          </template>

          <template v-slot:services="{ data }">
            <div class="color-blue" v-if="data.item.services">
              Услуги: {{ data.item.services.length || 0 }}
            </div>
          </template>

          <template v-slot:editSlot="{ data }">
            <i @click.stop
               class="icon edit icon-btn"
               title="Редактировать"
               @click="onSelection(data.item)"
               data-qa="buttonEditTransportBP"
            />
          </template>

          <template v-slot:deleteSlot="{ data }">
            <div class="delete-col">
              <i title="Удалить" class="delete-icon icon close-sm" @click.stop="deleteGroup(data.item)" data-qa="buttonDeleteTransportBP" />
            </div>
          </template>

          <template slot="noneContent">
            <div class="no-items">
              <p>Здесь вы сможете объединять ваши услуги по типам транспорта. Для этого добавьте хотя бы одну группу.</p>
              <ObButton
                  class="addGroupButton"
                  label="Добавить группу типов транспорта"
                  type="flat"
                  icon="plus"
                  @click="onAddGroup()"
                  data-qa="buttonAddTransportBP"
              />
            </div>
          </template>

          <template class="w100" v-slot:service="{ data }">
            <div class="service-item" v-if="data.item">
              <div class="service-item__title">
                {{ getServiceTitle(data.item.uuid) }}
              </div>
              <i title="Удалить" class="delete-icon icon close-sm" @click="deleteService(data.item)" data-qa="buttonDeleteServiceBP" />
            </div>
          </template>

        </ob-table>


      <ObModal
          ref="basePriceTransportTypeGroupAdd"
          title="Группа типов транспорта"
          :title-second="selectedGroup.uuid? 'Редактирование': 'Добавление'"
          custom-class="modal-large"
          @closed="closeEditPopup"
          data-qa="modalTransportTypeGroupFormBP"
      >
        <BasePriceTransportTypeGroupForm
            :data-source="selectedGroup"
            @save="onEditSave"
        />
      </ObModal>

      <ObModal
          ref="deleteServiceModal"
          title="Удаление"
          size="medium"
          :is-show-controls="true"
          ok-text="Удалить"
          @submit="onDeleteService"
          data-qa="modalDeleteServiceBP"
      >
        Вы точно хотите удалить услугу: "<span v-if="serviceForDelete" class="color-blue">{{ getServiceTitle(serviceForDelete.uuid) }}</span>" ?
      </ObModal>

      <ObModal
          ref="deleteGroupModal"
          title="Удаление группы"
          size="medium"
          :is-show-controls="true"
          ok-text="Удалить"
          @submit="onDeleteGroup"
          data-qa="modalDeleteGroupBP"
      >
        Вы точно хотите удалить группу: "<span v-if="groupForDelete" class="color-blue">{{ groupForDelete.title }}</span>" ?
      </ObModal>

    </div>
</template>

<script>
import api from '@/api';
import ObTable from 'common-components/src/obComponents/obTable';
import ObModal from 'common-components/src/obComponents/obModal';
import ObButton from 'common-components/src/obComponents/obButton';
import BasePriceTransportTypeGroupForm from '../modal/transportTypeForm';
import {mapActions, mapGetters} from "vuex";

export default {
  name: 'BasePricesClusteringTransportType',

  components: {
    ObTable,
    ObModal,
    ObButton,
    BasePriceTransportTypeGroupForm,
  },
  data() {
    return {
      isLoading: false,
      selectedGroup: {},
      serviceForDelete: null,
      groupForDelete: null,
      hideInactive: false,
      groups: [],
      usersInfo: [],
      subTableAction: {
        index: 1,
        icon: 'edit',
        text: 'Редактировать список'
      },
    }
  },
  computed: {
    ...mapGetters({
      services: 'base_prices/services',
    }),
    columns () {
      return [
        {
          title: 'Наименование',
          key: 'uuid',
          slotName: 'service',
        },
      ]
    },
    groupColumns () {
      return [
        {
          title: 'Наименование',
          key: 'title',
          slotName: 'title',
        },
        {
          title: 'Загружено',
          key: 'createdAt',
          slotName: 'createdAt',
        },
        {
          title: 'Автор',
          key: 'authorUuid',
          slotName: 'authorUuid',
        },
        {
          title: '',
          key: 'services',
          slotName: 'services',
          width: 130,
        },
        {
          title:'',
          slotName: 'deleteSlot',
          isAlignRight: true
        },
      ]
    },
  },
  created() {
    this.getServices();
  },
  methods: {
    ...mapActions({
      getServices: 'base_prices/getServices',
    }),
    async getTransportGroups({ page, size }) {
      try {
        this.isLoading = true;
        let data = await api.base_prices_clustering.getTransportGroups( { page_size: size, page_num: page });
        if (data.content && data.content.length) {
          let authorUuids = [];
          data.content.filter((e, i ,a) => {
            let res = a.findIndex((t) => t.authorUuid === e.authorUuid) === i;
            if (res) {
              authorUuids.push(data.content[i].authorUuid)
            }
            return res;
          });
          let usersInfo = await api.adminPanel.users.getUsersInfo(authorUuids)
          if (usersInfo.list.length) {
            this.usersInfo = usersInfo.list;
          }

          // форматируем и дополняем данные
          data.content = data.content.map((item) => {
            return {
              ...item,
              userInfo: this.getUserInfo(item.authorUuid),
              isOpenedSubTable: false
            }
          });
        }

        data.page = data.pageNum;
        data.size = data.pageSize;
        this.isLoading = false;

        return data;

      } catch (e) {
        this.isLoading = false;
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },
    getSubtableData(data) {
      let group = data.item;
      let subdata = {
        content: group.services.map(item => {
          let record = {
            group_uuid: group.uuid,
            uuid: item,
            group: group,
          }
          return record;
        }),
        page: null,
        size: group.services.length,
        totalElements: null,
        totalPages: 1,
        numberOfElements: group.services.length,
      }
      return subdata;
    },
    onSearch() {

    },
    onAddGroup() {
      this.selectedGroup = {};
      this.$refs.basePriceTransportTypeGroupAdd.show();
    },
    onEditGroup(data) {
      let formParams = data.item;
      formParams.resourceType = formParams.services ? formParams.services.map(a => a.uuid) : [];
      this.selectedGroup = formParams;
      this.$refs.basePriceTransportTypeGroupAdd.show();
    },
    closeEditPopup() {
      this.$refs.basePriceTransportTypeGroupAdd.hide();
    },
    onEditSave() {
      this.closeEditPopup();
      this.reloadTable();
      if(this.selectedGroup) {
        this.selectedGroup.isOpenedSubTable = !this.selectedGroup.isOpenedSubTable;
      }
    },
    deleteService(service) {
      this.serviceForDelete = service;
      this.$refs.deleteServiceModal.open();
    },
    async onDeleteService() {
      this.$refs.deleteServiceModal.close();
      try {
        await api.base_prices_clustering.deleteTransportGroupService(this.serviceForDelete.group_uuid, this.serviceForDelete.uuid);
        this.$notification({
          type: 'system_notification_success',
          message: `Тип транспорта удален`
        });
        await this.reloadTable();
        this.serviceForDelete.group.isOpenedSubTable = !this.serviceForDelete.group.isOpenedSubTable;
      } catch (e) {
        this.$notification({type: 'system_notification_error', message: 'Ошибка удаления: '+e.error_message});
      }
      this.serviceForDelete = null;
    },
    deleteGroup(group) {
      this.groupForDelete = group;
      this.$refs.deleteGroupModal.open();
    },
    async onDeleteGroup() {
      this.$refs.deleteGroupModal.close();
      try {
        await api.base_prices_clustering.deleteTransportGroup(this.groupForDelete.uuid);
        this.$notification({
          type: 'system_notification_success',
          message: `Группа удалена`
        });
        await this.reloadTable();
      } catch (e) {
        this.$notification({type: 'system_notification_error', message: 'Ошибка удаления группы'});
      }
      this.groupForDelete = null;
    },
    async changeGroupTitle(title, uuid) {
      if (!title || !uuid) {
        return false;
      }
      try {
        await api.base_prices_clustering.updateTransportGroup(uuid, title);
        this.$notification({
          type: 'system_notification_success',
          message: `Группа переименована`
        });
        await this.reloadTable();
      } catch (e) {
        this.$notification({type: 'system_notification_error', message: 'Ошибка переименования группы'});
      }
    },
    getUserInfo(userUuid) {
      if (this.usersInfo.length) {
        let userData = this.usersInfo.find(user => user.uuid === userUuid);
        if (userData) {
          return userData.firstname + ' ' + userData.lastname;
        }
      }
      return 'Не найден';
    },
    getIconClass(transportationWay) {
      let icon;
      switch (transportationWay) {
        case 'CONTAINER':
          icon = 'container';
          break;
        case 'RAIL':
          icon = 'carriage';
          break;
        default:
          icon = 'truck-sm';
      }
      return icon;
    },
    getServiceTitle(uuid) {
      if(this.services && this.services[uuid]) {
        let title = this.services[uuid].resourceSubtypeTitle + " " + this.services[uuid].resourcePatternParameter;
        return title;
      }
    },
    reloadTable() {
      this.$refs.transportClusteringTable.loadData();
    },
  },
}
</script>

<style lang="scss" scoped>
.service-item {
  display: flex;
  align-items: center;
  justify-content: space-between;
  width: 100%;

  &__title {
    margin-left: 80px;
  }
}

.addServiceButton {
  margin-left: 83px;
  span {
    font-size: 14px;
  }
  i {
    color: #9DA0AC;
    transition: all 0.2s linear;
  }

  &:hover{
    i {
      color: $blue-dust;
    }
  }
}

.color-blue {
  color: $blue-dust;
}
</style>